<?php

namespace Drupal\ai_support_bot\Controller;

use Drupal\Core\Controller\ControllerBase;
use Drupal\ai_support_bot\Controller\AISupportClientsCheck;

/**
 * AI Support Bot clear class.
 *
 * @AIQAnswers
 * Defines AIQAnswers Controller class.
 */
class AIQAnswers extends ControllerBase
{
    protected $connection;
    protected $config;
    /**
     * Constructs a new HelloForm object.
     */
    public function __construct()
    {
        $this->config = \Drupal::config('ai_support_bot.settings');
        $this->connection = \Drupal::database();
    }
    /**
     * Get question.
     */
    public function getQuestionAnswer($question)
    {
        if (strtolower($question) == 'no' || strtolower($question) == 'nope' || strtolower($question) == 'not') {
            return 'I see, sorry for that. Let\'s try again, How can I help you?';
        }
        $noNeedWords = [
          'the', 'on', 'if', 'that', 'is', 'a', 'at', 'are',
          'for', 'about', 'looking', 'what', 'but', 'you',
          'how', 'not', 'this'
        ];
        $randomAnswer = [
          'does this help?',
          'is this what you are looking for?',
          'did this answer your question?'
        ];
        $randomAnswer1 = [
          'This is what I found ',
          'Here\'s what I found ',
          'Maybe this can help '
        ];
        $randomNoAnswer = [
          ' Sorry couldn\'t understand your question "' . $question . '", can you be more specific please!',
          ' Your question "' . $question . '", is not clear!',
          ' I couldn\'t find answer to "' . $question . '"',
          ' Sometimes as a bot I cannot understand all questions, for example "' . $question . '", try another something else',
          ' I don\'t have an answer to "' . $question . '"',
          ' Life is hard sometimes, nothing related to "' . $question . '"',
        ];
        $q1 = strtolower($question);
        $qArr = explode(' ', $q1);
        $answers = '';
        $questions = '';
        $result = [];
        $answer = 'no-answer';
        $query = db_select('ai_support_bot', 'v');
        $query->fields('v');
        $results = $query->execute()->fetchAll();

        foreach ($results as $key => $value) {
            // Test if question has the words in full.
            if (strpos($q1, strtolower($value->words)) !== false) {
                $answer = $value->answers;
                $this->storeNewQuestion($value->words, $value->qid, $value->answers);
                break;
            }
            // Test if question has the words in full.
            if (strpos(strtolower($value->words), '<or>') !== false) {
                $newWords = $this->multiexplode(['<or>', ' <or>', ' <or> ', '<or> '], $value->words);
                foreach ($newWords as $newkey => $newvalue) {
                    if (strpos($q1, strtolower($newvalue)) !== false) {
                        $answer = $value->answers;
                        $this->storeNewQuestion($value->words, $value->qid, $value->answers);
                        break;
                    }
                }
            } else {
                if (strpos($q1, strtolower($value->words)) !== false) {
                    $answer = $value->answers;
                    $this->storeNewQuestion($value->words, $value->qid, $value->answers);
                    break;
                }
            }

            // Test if question contains the word.
            if (in_array(strtolower($value->words), $qArr)) {
                $answer = $value->answers;
                $this->storeNewQuestion($value->words, $value->qid, $value->answers);
                break;
            }
        }
        // Search contents by title.
        $answersResult = [];
        if ($answer == 'no-answer') {
            $query = db_select('node_field_data', 'v');
            $query->fields('v');
            $results = $query->execute()->fetchAll();
            $rm1 = array_rand($randomAnswer1);
            $i = 0;
            foreach ($results as $key => $value) {
                // Test if question contains the word.
                $title = explode(' ', $value->title);
                foreach ($title as $key1 => $tvalue) {
                    if (!in_array(strtolower($tvalue), $noNeedWords)) {
                        if (in_array(strtolower($tvalue), $qArr)) {
                            if (count($answersResult) < 5) {
                                $answersResult[] = '<a href="/node/' . $value->nid . '">' . $value->title . '</a>';
                            }
                        }
                    }
                }
            }
        }
        if (count($answersResult) > 0) {
            $rm = array_rand($randomAnswer);
            $answer = $randomAnswer1[$rm1];
            foreach ($answersResult as $key => $value) {
                $answer .= '<br>'. ((int)$key+1) . ' - ' . $value;
            }
            $answer .= '<br>'.$randomAnswer[$rm];
        }
        if ($answer == 'no-answer') {
            $rm = array_rand($randomNoAnswer);
            $answer = $randomNoAnswer[$rm1];
        }
        $this->storeNewQuestion($question, 0, $answer);
        // If not found.
        return $answer;
    }

    /**
     * Store question.
     */
    private function storeNewQuestion($question = '', $qid = 0, $answer = '')
    {
        $user = \Drupal::currentUser();
        // Empty the table.
        $values = [];
        $query = db_select('ai_support_bot_new_questions', 'v');
        $query->condition('v.question', $question);
        $query->fields('v');
        $results = $query->execute()->fetchAll();
        if (!empty($results)) {
            foreach ($results as $key => $value) {
                // Test if question contains the word.
                if (strtolower($value->question) == $question) {
                    $query = \Drupal::database()->update('ai_support_bot_new_questions');
                    $query->fields([
                      'times_repeated' => ($value->times_repeated + 1),
                      'created' => \Drupal::time()->getRequestTime(),
                    ]);
                    $query->condition('qid', $qid);
                    $query->execute();
                    break;
                }
            }
        } else {
            $values[] = [
              'question' => $question,
              'answer' => $answer,
              'qid' => $qid,
              'times_repeated' => 1,
              'created' => \Drupal::time()->getRequestTime(),
              'status' => 1,
              'uid' => $user->uid,
            ];
            $query = $this->connection->insert('ai_support_bot_new_questions')->fields(['question', 'answer', 'qid', 'times_repeated', 'created', 'status']);
            foreach ($values as $record) {
                $query->values($record);
            }
        }
        $query->execute();
        $qid =  $query->qid;
        //  IF analytics is on
        if ($this->config->get('share_analytic_ddkits') == 1) {
            $send = new AISupportClientsCheck;
            try {
                $host = \Drupal::request()->getHost();
                $results = $send->ai_analytics_send_questions($question, $qid, $answer, $host);
                // Logs a notice
                \Drupal::logger('ai_support_bot')->notice($results);
            } catch (\Throwable $th) {
                // Logs an error
                \Drupal::logger('ai_support_bot')->error($th);
            }
        }
        // end of send
        return;
    }
    public function multiexplode($delimiters, $string)
    {
        $ready = str_replace($delimiters, $delimiters[0], $string);
        $launch = explode($delimiters[0], $ready);
        return  $launch;
    }
}
